// Calendar generator.  Original program in C, May 1, 1990
// Converted to Java on Sept. 23, 1999
//
// Kerry Newman  -  newman@wt.net
// http://web.wt.net/~newman/

import java.awt.*;
import java.applet.*;

public class calendar extends Applet
{
  Button m100;
  Button m10;
  Button m1;
  TextField yearbox;
  Button p1;
  Button p10;
  Button p100;

  int day[] = new int[12];
  int row, col, year, week, i, day_week;  
  int lineinc = 16;
  int daysinmonth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
  int lindex;

  String moname[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep" ,"Oct", "Nov", "Dec" }; //Month names
  String line = "";

  public void init()
  {
    m100 = new Button("-100");
    m10  = new Button("-10");
    m1   = new Button("-1");
    yearbox = new TextField(5);  //box to put year in.
    p1   = new Button("+1");
    p10  = new Button("+10");
    p100 = new Button("+100");
    add ( m100 );
    add ( m10 );
    add ( m1 );
    add ( yearbox);
    add ( p1 );
    add ( p10 );
    add ( p100 );
    yearbox.setText("1999");
  }

  public void paint( Graphics g )
  {
    Font font = new Font( "Courier", Font.PLAIN, 16 ); //Fixed width font needed
    g.setFont( font );

    String Year = yearbox.getText();
    year = Integer.parseInt(Year);
    lindex = 60;

    if ( year < 1901 )
    {
      g.drawString( "                 Please enter a year of 1901 or later!!", 10, lindex );
      return;
    }

    for ( i = 0; i <= 11; i++ )
      day[i] = 1;                      //initialize day of month to 1

    if (((year % 4) == 0) && (((year % 100) != 0) || ((year % 400) == 0)))
      daysinmonth[1] = 29;
    else
      daysinmonth[1] = 28;             //need to reset it back because only set to 28 in initialization

    for ( row= 0 ; row <= 3 ; ++row )  // 4 rows of months 1-2-3  4-5-6  7-8-9  10-11 12
    {
      line =  ( "          " + moname[ row*3  ] );  //assemble and print month names
      line = line.concat( "                        " + moname[ row*3 + 1 ] );
      line = line.concat( "                        " + moname[ row*3 + 2 ] );

      g.drawString( line, 10, lindex );  //print out name of months
      lindex += 2*lineinc;               //increment line space by 2.  One blank line.
      g.drawString( " Su Mo Tu We Th Fr Sa       Su Mo Tu We Th Fr Sa       Su Mo Tu We Th Fr Sa", 10, lindex );
      lindex += lineinc;
      line = "";
      for ( week = 0 ; week <= 5 ; ++week )  //week loops.  one line includes one week for 3 months.
      {
        line = "";
        for ( col = 0 ; col <= 2 ; ++col )   //3 months in a row
        {
          if (week == 0)         //1st week needs to know what day to start.
            firstweek( row*3 + col, year);
          else
            otherweek( row*3 + col );
        }   /* Column end  */

        g.drawString(line, 10, lindex);      //done with line, print it out.
        lindex += lineinc;

        line = "";

      }     /* Week end */
    }       /* Row end  */
    g.drawString(line, 10, lindex);
  }         /* Paint end */


  /////////////////// first week of the month /////////////////////
  public void firstweek( int month, int year )
  {
    int day_week, i;
    day_week = firstday ( month, year );  //go get starting day of week.
    for ( i = 0 ; i < day_week ; i++ )             //print blanks until 1st.
      line = line.concat("   ");                
    do
    {
      line = line.concat( "  " + String.valueOf( day[month] ) );  //print day of month with leading blank.
      ++day[month];
      ++day_week;
    }
    while (day_week <= 6 );   

    if ( ((month + 1) % 3) != 0 )  //if last day of week, print spaces between month.
      line = line.concat("      ");
    day_week = 0;
  }


  /////////////////// weeks 2 - 6 /////////////////////
  public void otherweek( int month )
  {
    day_week = 0;               //initialize day of week to 0.  Sunday

    do
    { 

      if ( day[month] <= daysinmonth[ month ] )  //check to see if days still left.
      {
        if ( day[month] < 10 )  //if 1-9, 2 leading spaces needed.
          line = line.concat( "  " + String.valueOf( day[month] ) );
        else                    //if 10-31, 1 leading space needed.
          line = line.concat( " " + String.valueOf( day[month] ) );
          ++day[month];
          ++day_week;
      }
      else
      {
        line = line.concat("   ");  //if after last day of month, print blanks.
        ++day_week;
      }

    }
    while ( day_week <= 6 );

    if ( ((month + 1) % 3) != 0 )  //if last day of week, print spaces between month.
      line = line.concat("      ");
  } 
  //end of otherweek


  /////////////////// first day of month /////////////////////
  public int firstday( int month, int year )
  {
    int yeardiff, days_since, dayofyear[]={ 0,31,59,90,120,151,181,212,243,273,304,334 };
    yeardiff = year - 1901;
    days_since = yeardiff * 365;
    days_since += ( ( yeardiff/4 ) - ( yeardiff/100 ) + ((yeardiff+300)/400) ) + dayofyear[ month ];
    if (((((year % 4) == 0) && (((year % 100) != 0) || ((year % 400) == 0)))) && ( month > 1 ))
      days_since++;
    return ( ( days_since + 2 ) % 7 );
  }


  protected void HandleButtons(Object label)
  {
    String NewYear;
    if ( label == "-100" )
        year = year - 100;
    else if ( label == "-10" )
        year = year - 10;
    else if ( label == "-1" )
        year = year - 1;
    else if ( label == "+1" )
        year = year + 1;
    else if ( label == "+10" )
        year = year + 10;
    else if ( label == "+100" )
        year = year + 100;

    NewYear = String.valueOf( year );
    yearbox.setText( NewYear );
  }

  public boolean action(Event event, Object arg )
  {
    if (event.target instanceof Button )
      HandleButtons(arg);
    repaint();
    return true;
  }
}